local mod = ...



-- Happiness factor -------------------------------------------------------------------------------------
mod:register({
    DataType = "HAPPINESS_FACTOR",
    Id = "HAPPINESS_FACTOR_ENTERTAINMENT",
    Value = -2,
    IsDecaying = true,
    TimeBeforeDecayingSeconds = 120.0,
    DecayingRatePerMinute = 3.5, -- default is 2.0
    IsCumulative = true,
    IsSolvable = true,
    RemovedOnDecayed = false
})



-- Villager Need Type -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Entertainment.png", "ICON_ENTERTAINMENT")

mod:register({
    DataType = "VILLAGER_NEED_TYPE",
    Id = "NEED_ENTERTAINMENT",
    NeedTypeName = "NEED_ENTERTAINMENT_NAME",
    NeedTypeList = {"ENTERTAINMENT"}, -- this need type already exists in the vanilla game
    FillDurationInSeconds = 1680, -- 420 seems to be the duration of water and food, 2-3 days
    FillRate = 100,
    GracePeriod = 7,
    HappinessFactor = "HAPPINESS_FACTOR_ENTERTAINMENT",
    ResourceTypeIcon = "ICON_ENTERTAINMENT"
})



-- Villager need -------------------------------------------------------------------------------------
mod:override({
    Id = "COMMONER", -- This is inherited by all higher statuses automatically
    AssetVillagerNeedList = {
        Action = "APPEND", "NEED_ENTERTAINMENT"
    }
})



-- Resource: Entertainment -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Entertainment.png", "ICON_ENTERTAINMENT")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_ENTERTAINMENT",
	ResourceName = "RESOURCE_ENTERTAINMENT_NAME",
	Icon = "ICON_ENTERTAINMENT",
	ResourceTypeList = { "ENTERTAINMENT" },
	VillagerBuyingPrice = {
		Resource = "GOLD_COINS",
		Quantity = 2
	},
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = true,
	OrderId = 0
})



-- Resource: Experience -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Experience.png", "ICON_EXPERIENCE")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_EXPERIENCE",
	ResourceName = "RESOURCE_EXPERIENCE_NAME",
	Icon = "ICON_EXPERIENCE",
	ResourceTypeList = { "RESOURCE" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false
})



-- Building: Entertainment -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_ENTERTAINMENT",
	Name = "BUILDING_ENTERTAINMENT_NAME",
	Description = "BUILDING_ENTERTAINMENT_DESC",
	BuildingType = "MONUMENT",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_ENTERTAINMENT1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_ENTERTAINMENT_PERFORMER1",
				"BUILDING_PART_ENTERTAINMENT_PERFORMER2",
				"BUILDING_PART_ENTERTAINMENT_PERFORMER3",
				"BUILDING_PART_ENTERTAINMENT_SPOT",
			}
		},
		{
			Name = "BUILDING_SET_ENTERTAINMENT3_NAME",
			BuildingPartList = { 
				"STAGE_PART",
				-- "BUILDING_PART_ENTERTAINMENT_STAGE_FRAME",
				"STAIRS_WOODEN_PART",
				"STANDS_PART",
				"STANDS_COVERED_PART",
				"GATE_PART",
				"GATE_ROPE_PART",
				"BACKDROP_RED_PART",
				"BACKDROP_ORANGE_PART",
				"BACKDROP_GREEN_PART",
				"BACKDROP_BLUE_PART",
				"BACKDROP_TEAL_PART",
				"BACKDROP_PURPLE_PART",
				"GATE_FLAGS_RB_PART",
				"GATE_FLAGS_BY_PART",
				"GATE_FLAGS_GW_PART",
			}
		},
		{
			Name = "BUILDING_SET_ENTERTAINMENT2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_ENTERTAINMENT_PEN",
				"BUILDING_PART_ENTERTAINMENT_WALL",
				"BUILDING_PART_ENTERTAINMENT_GATE",
				"BUILDING_PART_ENTERTAINMENT_KEEPER",
				"BUILDING_PART_ENTERTAINMENT_BEAR",
				"BUILDING_PART_ENTERTAINMENT_CAMEL",
				"BUILDING_PART_ENTERTAINMENT_GIRAFFE",
				"BUILDING_PART_ENTERTAINMENT_RHINOCEROS",
				"BUILDING_PART_ENTERTAINMENT_LION",
				"BUILDING_PART_ENTERTAINMENT_ELEPHANT",
				"BUILDING_PART_ENTERTAINMENT_MONKEY",
			}
		},
    },
	-- RequiredPartList = {
	-- 	{ Category = "CORE", Min = 1, Max = 1 },
	-- },
	VillagerRequired = { Status = "COMMONER", Quantity = 1 },
	IsEditable = true
})

