local mod = ...


--[[

Quest fills Entertainment need for the first 90 days

]]



-- Default Balancing (event list) ---------------------------------------------------------------------------------------------
mod:override({
    Id = "DEFAULT_BALANCING",
    EventList = {
        Action = "APPEND",
        "EVENT_ENTERTAINMENT_START",
    }
})



-- Event: Entertainment Start ---------------------------------------------------------------------------------------------
mod:register({
	DataType = "EVENT",
    Id = "EVENT_ENTERTAINMENT_START",
    IsInMainPool = false, -- the main pool seems to suppress itself until the first Weather event fires, so custom events should be outside the main pool
    IsRecurrent = false,
    DaysBetweenOccurences = nil,
    DaysToFirst = 1,
    Delay = 1, 
    ConditionList = {
    },
	ActionList = {
        {
            DataType = "EVENT_ACTION_GIVE_QUEST",
            Quest = "QUEST_ENTERTAINMENT_START"
        },
    }
})



-- Quest: Entertainment Start ---------------------------------------------------------------------------------------------
mod:register({
    DataType = "QUEST",
    Id = "QUEST_ENTERTAINMENT_START",
    IsSilent = false,
	QuestFunction = {
        DataType = "QUEST_FUNCTION_PLACE_BUILDING", 
        BuildingListToPlace = { "BUILDING_VILLAGE_CENTER" }
    },
    QuestRewardList = {
        {
            DataType = "QUEST_REWARD_GAME_RULE",
            RuleModifier = {
                DataType = "GAME_RULE_MODIFIER_NEED_PERMANENTLY_FILLED",
                NeedResource = "RESOURCE_ENTERTAINMENT",
                DurationInDays = 2
            }
        },
    },
    QuestFailList = nil,
    QuestListToUnlockAfter = nil,
    OnFailCallback = nil
})

